.\" DAL DaSetRegChunk(3) manpage
.\"
.\"
.\" +============================================+
.\" |  Author:          Yury Georgievskiy, CERN  |
.\" |  Creation date:   08.05.2007               |
.\" +============================================+
.\"
.\"
.TH DASETREGCHUNK "3" "May 2007" "Driver Access Library" "DAL User's Manual"
.SH NAME
DaSetRegChunk \- set a chunk of the \fBspecific\fR register, which consists
of several elements
.SH SYNOPSIS
.B int DaSetRegChunk(HANDLE \fIhandle\fB, int \fIrId\fB, long \fIelOffs\fB, unsigned int \fIelN\fB, void* \fIbuf\fB, int \fIcount\fB);
.SH DESCRIPTION
The \fIDaSetRegChunk()\fR function attempts to set a chunk (i.e. specified set
of register elements) of a so-called \fBspecific\fR register \fIrId\fR. It's
not an actual register, but rather a chunk of memory with the specified ID,
that consists of several elements with the \fBsame\fR granularity (byte, word,
double word, etc...). So \fBspecific\fR registers can be considered either as
a set of the \fBnormal\fR registers (i.e. each element is a register itself)
that are grouped together for convenience, or it can be just a chunk of memory
with several elements of the same size. Granularity and ID of such memory
chunks are set in the DataBase. Number of register elements and their size
(\fIwhich is identical in case of several elements!\fR) depends on the register
definition itself, and can be obtained by means of two functions:
.TP
.B 1. \fIDaGetRegDepth\fR
- get number of elements in the register Minimum one (1)
.TP
.B 2. \fIDaGetRegSize\fR
- get size of each element
.P
Function operates in terms of element offset inside the \fBspecific\fR
register, and expects an offset of the first element to set in \fIelOffs\fR
parameter. Buffer \fIbuf\fR should contain as many data as needed to set into
a specified memory chunk.
.sp
For example, if register is a set of integers and user wants to	set 5 elements
of this register, then buffer \fIbuf\fR should contain data to set and his size
\fIcount\fR should be:
.sp
5elements x 4bytes_each = 20 bytes long
.TP
.I handle
- is a library handle, returned by \fIDaEnableAccess()\fR call
.TP
.I rId
- is register ID that should be examine. ID of each Module register can be
found in \fI<ModuleName>RegId.h\fR file, which is located
in a standart include directory of a given Module:
\fI/ps/local/$(CPU)/drvrutil/include/<ModuleName>include\fR.
.TP
.I elOffs
- element offset inside the register (\fIexpressed in element index!\fR)
.TP
.I elN
- number of register elements to get (minimum 1)
.TP
.I buf
- buffer holds a values that should be assigned to the register chunk.
.TP
.I count
- is a buffer size in bytes.
.SH RETURN VALUE
On success, \fITHE NUMBER OF SET REGISTER ELEMENTS\fR is returned
(Minimum \fI1\fR). You can get register depth using \fIDaGetRegDepth()\fR
function.
.sp
On failure the return code is:
.TP
.B 0
- shortcoming or overflow of provided data
.TP
.B -DA_ERR_BAD_HANDLE
- provided \fIhandle\fR is bad
.TP
.B -DA_ERR_NO_REG
- no such register
.TP
.B -DA_ERR_INT_ERR
- can't set register value for some reason. Information is printed out on the
stderr if \fBDA_DBG_ERR_INFO\fR flag is set (see \fIDaDbgFlag()\fR for more
info about debug flags)
.TP
.B -DA_ERR_REG_BOUNDS
- required elements are beyond register bounds
.TP
.B -DA_ERR_NOT_INIT
- library was not initialized, i.e. \fIDaEnableAccess()\fR was not called
.SH AUTHOR
Written by Yury Georgievskiy (ygeorgie (at) gmail.com)
.SH SEE ALSO
.BR driverGen (8),
.BR modinst (8),
.BR moduninst (8),
.BR dal (3),
.BR DaEnableAccess (3),
.BR DaDisableAccess (3),
.BR DaSetDefAM (3),
.BR DaGetDefAM (3),
.BR DaGetNodeFd (3),
.BR DaGetRegister (3),
.BR DaGetRegChunk (3),
.BR DaSetRegister (3),
.BR DaGetRegDepth (3),
.BR DaGetRegSize (3),
.BR DaGetRegRep (3),
.BR DaSetRegRep (3),
.BR DaGetRegAccessRights (3),
.BR DaGetRegName (3),
.BR DaDrvrVers (3),
.BR DaLibVers (3),
.BR DaDbgFlag (3),
.BR DaGetErrCode (3),
.BR DaUserEntryPoint (3)
